# WARNING - Generated by {fusen} from /dev/flat_study_squirrels.Rmd: do not edit by hand

#' Permet de sauvegarder des données en format csv
#' 
#' permet d’enregistrer le jeu de données en csv avec la fonction write.csv2() du package {utils} au chemin spécifié
#' 
#' @param data le jeu de données à sauvegarder
#' @param path le chemin du fichier 
#' 
#' @importFrom tools file_ext
#' @importFrom utils write.csv2
#' 
#' @return le chemin complet du csv créé
#' 
#' @export
#' @examples
#' # Création d'un dossier temporaire
#' mon_dossier_temp <- tempfile(pattern = "savecsv")
#' dir.create(mon_dossier_temp)
#' 
#' # ok : le fichier .csv est enregistré dans le projet actuel
#' iris %>% save_as_csv(file.path(mon_dossier_temp, "output.csv"))
#' 
#' # ok : le fichier .csv est enregistré et le fichier s'ouvre
#' iris %>% save_as_csv(file.path(mon_dossier_temp, "output.csv")) %>% browseURL()  
save_as_csv <- function(data, path){
  if(isFALSE(is.data.frame(data))){
    stop("data is not a dataframe")
  }
  
  if(nrow(x = data) == 0){
    stop("data have 0 rows")
  }
  
  if(isFALSE(tools::file_ext(x = path) == "csv")){
    stop("path don't have a .csv extension")
  }
  
  if(isFALSE(dir.exists(dirname(path = path)))){
    stop("Directory doesn't exist")
  }
  
  write.csv2(x = data, file = path)
  
  return(path)
}

#' Study the activities of the squirrels given a primary fur color
#'
#' @param df_squirrels_act Data frame. A dataset with the activities of the squirrels. This dataset mush have at leat these 4 columns: "age", "primary_fur_color", "activity", "counts".
#' @param col_primary_fur_color Character. The color of the primary fur color of interest. Only the squirrels with this primary fur color will be considered in the analysis.
#' 
#' @importFrom dplyr filter
#' @importFrom ggplot2 ggplot aes geom_col scale_fill_manual labs
#' @importFrom magrittr %>% 
#'
#' @return A list of two named elements. The first one is the filtered table. The second one is the ggplot.
#' @export
#'
#' @examples
#' data(data_act_squirrels)
#' study_activity(df_squirrels_act = data_act_squirrels, 
#'                col_primary_fur_color = "Gray")
study_activity <- function(df_squirrels_act, col_primary_fur_color) {
  
  check_squirrel_data_integrity(df_squirrels_act)
  
  if(isFALSE(is.data.frame(df_squirrels_act))) {
    stop("df_squirrels_act is not a data frame")
  }
  
  if(isFALSE(is.character(col_primary_fur_color))) {
    stop("col_primary_fur_color is not a character vector")
  }
  
  
  table <- df_squirrels_act %>% 
    filter(primary_fur_color == col_primary_fur_color)
    
  graph <- table %>% 
    ggplot() +
    aes(x = activity, y = counts, fill = age) +
    geom_col() +
    labs(x = "Type of activity",
         y = "Number of observations",
         title = glue("Type of activity by age for {tolower(col_primary_fur_color)} squirrels")) +
    scale_fill_manual(name = "Age",
                      values = c("#00688B", "#00BFFF"))
  
  return(list(table = table, graph = graph))
}
